{

TODO: Improve Water Tower Code
 - Accuracy
TODO: Get Gridlock Working (All snsrs on b)
TODO: Speed-Bumps, Bridge
TODO: End Tile
TODO: Time Trials
TODO: Polish everything up (i.e. Keyboard Control) 

}

CON

  _clkmode = xtal1 + pll8x
  _xinfreq = 10_000_000

  ARM_SPEED = 100
  MAX_SPEED = 90
  MIN_SPEED = 50
  LINE_LOST_TIMEOUT = 250

  SEND_AUXILLARY_INFO = true
  
OBJ

  LCD: "LCD"
  Mtr: "HB"
  Sensor: "Sensors"
  Cog: "CogManager"
  Profiler: "Profiler"
  Profiler1: "Profiler"
  Profiler2: "Profiler"
  PC: "ComputerComms"
  Claw: "Claw"
  Num: "Numbers"
  Gyro: "Gyroscope"

VAR

  long stack[100]
  long location
  byte speed
  byte turning, direction
  byte logicspeed
  long offcounter
  byte timesLostLine
  long timeFromLastGreenTurn
  byte cornersTurned
  byte gridlockTurnsCounter
  byte inGreenTile
  long prevDist

PUB Main

  '---{Init}---'
  Sensor.Start(4, 8, 9, 10, 11, 12, 5)
  Mtr.Start(1, 2, 3)
  cognew(DebugLoop, @stack[0])
  location := String("Starting Tile")
  speed := MAX_SPEED
  
  
  '------------'

  inGreenTile := False
  
  repeat
    Profiler.StartTimer

    DetectLocation

    if strcomp(location, string("Gridlock"))
      speed := 90
      FollowLine
    else
      FollowLine
      
    'endif
      

    logicspeed := Profiler.StopTimerx


PUB DetectLocation

  'Off Line Counter'

  if timeFromLastGreenTurn > 0
    timeFromLastGreenTurn++

  if Sensor.getArmButton==1' and strcomp(location, string("Unknown Object"))
    mtr.halt
    waitcnt(clkfreq/5+cnt)
    if Sensor.getArmButton==1
      ToWaterTower
    else
      DetectLocation
  elseif sensor.getCmMiddle < 10 and not Sensor.getCmMiddle==0
    ToUnknownObject

  elseif strcomp(location, string("Unknown Object")) and sensor.getCmMiddle > 10
    ToLineFollowing 
    
  'If all the middle sensors are off the line...
  elseif Sensor.getLeftQTIColor==0 and Sensor.getRightQTIColor==0 and Sensor.getMiddleQTIColor==0
    if not strcomp(location, string("Starting Tile")) and offcounter < LINE_LOST_TIMEOUT
      offcounter++
    if offcounter => LINE_LOST_TIMEOUT
      ToOffLine
  'If in proper line following position
  elseif Sensor.getLeftQTIColor==0 and Sensor.getMiddleQTIColor==1 and Sensor.getRightQTIColor==0
    if not strcomp(location, string("In Green Tile")) and not strcomp(location, string("Unknown Object"))
      ToLineFollowing
  elseif Sensor.getLeftQTIColor==1 and Sensor.getMiddleQTIColor==1 and Sensor.getRightQTIColor==1 
    if strcomp(Sensor.getLeftCPALColor, string("Green"))  
      ToLeftCorner
    elseif strcomp(Sensor.getRightCPALColor, string("Green"))
      ToRightCorner

PUB ToWaterTower | startDistFromTower, endHeading, distFromTowerToUphold

  location := string("Water Tower")

  Mtr.Halt

  endHeading := Sensor.getDegrees-90

  Mtr.Backward(MIN_SPEED, 300)

  startDistFromTower := 73
  distFromTowerToUphold := 50

  repeat until Sensor.getMmMiddle > startDistFromTower
    Mtr.Backward(MIN_SPEED, 10)
  repeat until Sensor.getMmMiddle == startDistFromTower
    if Sensor.getMmMiddle > startDistFromTower
      Mtr.Forward(MIN_SPEED, 10)
    elseif Sensor.getMmMiddle < startDistFromTower
      Mtr.Backward(MIN_SPEED, 10)

  repeat 4
    repeat
      if Sensor.getMmRight < distFromTowerToUphold
        quit
      Mtr.SpinLeft(MAX_SPEED, 10)
    waitcnt(clkfreq/5+cnt)
  Mtr.SpinLeft(MAX_SPEED, 300)

  repeat until Sensor.getMiddleQTIcolor==0
    if Sensor.getMmRight > distFromTowerToUphold and Sensor.getMmRight < distFromTowerToUphold + 20 
      Mtr.SpinRight(MAX_SPEED, 10)
    elseif Sensor.getMmRight > distFromTowerToUphold + 20
      repeat until Sensor.getMMRight < distFromTowerToUphold + 3
        Mtr.SpinLeft(MAX_SPEED, 30)
        Mtr.Forward(MAX_SPEED, 20)    
    else
      Mtr.Forward(MAX_SPEED, 10)
    prevDist := Sensor.getMmRight

  repeat 50
    if Sensor.getMmRight > distFromTowerToUphold and Sensor.getMmRight < distFromTowerToUphold + 20 
      Mtr.SpinRight(MAX_SPEED, 10)
    elseif Sensor.getMmRight > distFromTowerToUphold + 20
      repeat until Sensor.getMMRight < distFromTowerToUphold + 3
        Mtr.SpinLeft(MAX_SPEED, 30)
        Mtr.Forward(MAX_SPEED, 20)    
    else
      Mtr.Forward(MAX_SPEED, 10)
    prevDist := Sensor.getMmRight


  repeat until Sensor.getMiddleQTIcolor==1
    if Sensor.getMmRight > distFromTowerToUphold and Sensor.getMmRight < distFromTowerToUphold + 20 
      Mtr.SpinRight(MAX_SPEED, 10)
    elseif Sensor.getMmRight > distFromTowerToUphold + 20
      repeat until Sensor.getMMRight < distFromTowerToUphold + 3
        Mtr.SpinLeft(MAX_SPEED, 30)
        Mtr.Forward(MAX_SPEED, 20)    
    else
      Mtr.Forward(MAX_SPEED, 10)
    prevDist := Sensor.getMmRight

  Mtr.Forward(MAX_SPEED, 200)

  TurnLeftUnit(80)

  ToLineFollowing
      
PUB ToUnknownObject

  location := string("Unknown Object")
  speed := MIN_SPEED    

PUB ToLineFollowing

  location := string("Line Following")
  speed := MAX_SPEED

PUB ToEndTile

  location := string("End Tile")
  Mtr.Halt
  repeat

PUB ToOffLine

  if Sensor.getCmMiddle < 55
    Mtr.Forward(MAX_SPEED, 1000)
    repeat 5
      if strcomp(Sensor.getLeftCPALColor, string("Green")) and strcomp(Sensor.getRightCPALColor, string("Green"))
        ToEndTile
        return
      waitcnt(clkfreq/5+cnt)
    
    if strcomp(location, string("Line Following"))
      location := String("Off Line")
    timesLostLine++
    Mtr.halt
    repeat until Sensor.getMiddleQTIColor==1 or sensor.getLeftQTIColor==1 or sensor.getRightQTIColor==1
      Mtr.Backward(150, 50)
    if strcomp(location, string("Off Line"))
      location := String("Line Following")
          
  else
    if strcomp(location, string("Line Following"))
      location := String("Off Line")
    timesLostLine++
    Mtr.halt
    repeat until Sensor.getMiddleQTIColor==1 or sensor.getLeftQTIColor==1 or sensor.getRightQTIColor==1
      Mtr.Backward(150, 50)
    if strcomp(location, string("Off Line"))
      location := String("Line Following") 

PUB ToLeftCorner
  
  location := String("Green Corner Left")

  repeat 3
    CornerLeft

  UpdateInGreenTile
  CheckForGridlock
  
  cornersTurned++

PUB ToRightCorner

  location := String("Green Corner Right")

  repeat 3
    CornerRight

  UpdateInGreenTile
  CheckForGridlock

  cornersTurned++

PUB UpdateInGreenTile

  if inGreenTile==1
    inGreenTile:=0
  else
    inGreenTile:=1

PUB ToGridlock | x, a

  location := String("Gridlock")
  speed := MAX_SPEED
  Mtr.Halt

  timeFromLastGreenTurn := 9001

  repeat 2000
    FollowLine
            
  repeat x from 0 to 2
    repeat until Sensor.getLeftQTICOlor==1 and Sensor.getMiddleQTIColor==1 and Sensor.getRightQTIColor==1
      FollowLine
      timeFromLastGreenTurn := x
    repeat until Sensor.getLeftQTICOlor==0 and Sensor.getRightQTIColor==0 and Sensor.getMiddleQTIColor==1
      FollowLinex
      
      timeFromLastGreenTurn := x
      offcounter++ 

  x := false

  'Precondition: Robot is through 2 of the line crossings, but with the avaliability to
  'have only crossed one.
  'Idea is to get robot just after the 3rd turn in the course.

  speed := MAX_SPEED
  
  repeat
    if Sensor.getLeftQTIColor==1 and Sensor.getRightQTIColor==1 and sensor.getMiddleQTIColor==1
      Mtr.Halt
      waitcnt(clkfreq/4+cnt)
      repeat until Sensor.getLeftQTIColor==1 and Sensor.getRightQTIColor==1
        Mtr.Backward(MIN_SPEED, 10)
      if strcomp(Sensor.getRightCPALCOlor, string("Green"))
        CornerRight
        quit
      else
        Mtr.Forward(MAX_SPEED, 300)

    elseif Sensor.getLeftQTIColor==0 and Sensor.getRightQTIColor==0 and Sensor.getMiddleQTIColor==0
      repeat until Sensor.getLeftQTIColor==1 and Sensor.getRightQTIColor==1
        Mtr.Backward(MAX_SPEED, 10)      
    else
      FollowLine 

  'Precondition: Robot is just after 3rd (right) turn in the Gridlock of the course.

  x := false

  repeat until strcomp(Sensor.getLeftCPALCOlor, string("Green")) and Sensor.getLeftQTICOlor==1 and Sensor.getMiddleQTIColor==1 and Sensor.getRightQTIColor==1 
    FollowLine

  CornerLeft

  repeat 2000
    FollowLine

  inGreenTile := 0
  timeFromLastGreenTurn := 0
  ToLineFollowing

PUB CheckForGridlock

  if timeFromLastGreenTurn > 50 and timeFromLastGreenTurn < 6000 and not timeFromLastGreenTurn==0 and inGreenTile==0
    ToGridlock
    timeFromLastGreenTurn := 9001
  else
    timeFromLastGreenTurn := 1
    
PUB ToInGreenTile

  location := String("In Green Tile")
  speed := MAX_SPEED

PUB ToIfInGreenTile

  if strcomp(location, string("Gridlock"))
    inGreenTile := True
    location := string("Gridlock")
  else
    if inGreenTile == True
      inGreenTile := False
      ToLineFollowing
    elseif inGreenTile == False
      inGreenTile := True
      ToInGreenTile
  
'-----------------------------------'
  
PUB FollowLine | l, r, ol, or_, m

  l := Sensor.getLeftQTIColor
  r := Sensor.getRightQTIColor
  ol := Sensor.getOuterLeftQTIColor
  or_ := Sensor.getOuterRightQTIColor
  m := Sensor.getMiddleQTIColor

    
  if r==1
    Mtr.SetSpinRight(Speed)
  elseif l == 1
    Mtr.SetSpinLeft(Speed)
  elseif ol == 1
    Mtr.SetForwardRight(Speed)
  elseif or_ == 1
    Mtr.SetForwardLeft(Speed)
  else
    Mtr.SetForward(Speed)

PUB FollowLinex | l, r, ol, or_, m

  l := Sensor.getLeftQTIColor
  r := Sensor.getRightQTIColor
  ol := Sensor.getOuterLeftQTIColor
  or_ := Sensor.getOuterRightQTIColor
  m := Sensor.getMiddleQTIColor


  if l==1 and r==1 and m==1
    Mtr.SetForward(Speed)
  elseif r==1
    Mtr.SetSpinRight(Speed)
  elseif l == 1
    Mtr.SetSpinLeft(Speed)
  elseif ol == 1
    Mtr.SetForwardRight(Speed)
  elseif or_ == 1
    Mtr.SetForwardLeft(Speed)
  else
    Mtr.SetForward(Speed)
    
PUB FollowLineRight | l, r, ol, or_, m

  l := Sensor.getLeftQTIColor
  r := Sensor.getRightQTIColor
  ol := Sensor.getOuterLeftQTIColor
  or_ := Sensor.getOuterRightQTIColor
  m := Sensor.getMiddleQTIColor
  
  if r==1
    Mtr.SetSpinRight(Speed)
  elseif l==1
    Mtr.Forward(Speed, 50)
    Mtr.SetSpinLeft(Speed)
  elseif ol == 1
    Mtr.SetForwardRight(Speed)
  elseif or_ == 1
    Mtr.SetForwardLeft(Speed)
  else
    Mtr.SetForward(Speed)

PUB FollowLineLeft | l, r, ol, or_, m

  l := Sensor.getLeftQTIColor
  r := Sensor.getRightQTIColor
  ol := Sensor.getOuterLeftQTIColor
  or_ := Sensor.getOuterRightQTIColor
  m := Sensor.getMiddleQTIColor
  
  if l==1
    Mtr.SetSpinLeft(Speed)
  elseif r==1
    Mtr.Forward(Speed, 50)
    Mtr.SetSpinRight(Speed)
  elseif ol == 1
    Mtr.SetForwardRight(Speed)
  elseif or_ == 1
    Mtr.SetForwardLeft(Speed)
  else
    Mtr.SetForward(Speed)

PUB TurnLeftUnit(Unit) | endunit

  endunit := Sensor.getDegrees + Unit

  repeat until sensor.getDegrees > endunit - 3 and sensor.getDegrees < endunit + 3
    if sensor.getDegrees < endunit
      Mtr.SpinLeft(MAX_SPEED, 10)
    elseif sensor.getDegrees > endunit
      Mtr.SpinRight(MAX_SPEED, 10)

PUB TurnRightUnit(Unit) | endunit

  endunit := Sensor.getDegrees - Unit

  repeat until sensor.getDegrees > endunit - 3 and sensor.getDegrees < endunit + 3
    if sensor.getDegrees < endunit
      Mtr.SpinLeft(MIN_SPEED, 10)
    elseif sensor.getDegrees > endunit
      Mtr.SpinRight(MIN_SPEED, 10)

PUB CornerLeft

  speed := MAX_SPEED
  
  repeat until Sensor.getLeftQTIColor==0 and Sensor.getMiddleQTIColor==1 and sensor.getRightQTIColor==0
    FollowLineLeft
      
PUB CornerRight

  speed := MAX_SPEED

  repeat until Sensor.getLeftQTIColor==0 and Sensor.getMiddleQTIColor==1 and sensor.getRightQTIColor==0
    FollowLineRight

PRI DebugLoop | t, b
  {Dumps information to computer/lcd}

  '---{Init}---'
  LCD.Start(0) 
  PC.Start


  repeat
    Profiler1.StartTimer
    
    '---{Line Sensors}---'
    PC.SendInt(String("QTI-OL"), Sensor.getOuterLeftQTI)
    PC.SendInt(String("QTI-IL"), Sensor.getLeftQTI)
    PC.SendInt(String("QTI-M"), Sensor.getMiddleQTI)
    PC.SendInt(String("QTI-IR"), Sensor.getRightQTI)
    PC.SendInt(String("QTI-OR"), Sensor.getOuterRightQTI)

    PC.SendInt(String("PING-M"), Sensor.getCmMiddle)
    PC.SendInt(String("PING-R"), Sensor.getCmRight)

    PC.SendTuple5(String("BWSTRIP"), Sensor.getOuterLeftQTIColor, Sensor.getLeftQTIColor, Sensor.getMiddleQTIColor, sensor.getRightQTIColor, sensor.getOuterRightQTIColor) 

    PC.SendInt(String("SPEED-LOGIC"), logicspeed)
    PC.SendInt(String("SPEED-SENSOR1"), Sensor.getFastLastMs)
    PC.SendInt(String("SPEED-SENSOR2"), Sensor.getSlowLastMs)
    PC.SendInt(String("SPEED-DEBUG"), t)
    PC.SendInt(String("SPEED-SENSOR3"), sensor.getMediumLastMs)   

    PC.SendInt(String("COGS-USED"), Cog.getUsedCogs)

    PC.SendStr(String("LOCATION"), location)

    PC.SendInt(String("HEADING"), sensor.getDegrees)
    
    {PC.AddValueInt(String("QTI-OL-COLOR"), Sensor.getLeftQTIColor)
    PC.AddValueInt(String("QTI-IL-COLOR"), Sensor.getRightQTIColor)
    PC.AddValueInt(String("QTI-M-COLOR"), Sensor.getMiddleQTIColor)
    PC.AddValueInt(String("QTI-IR-COLOR"), Sensor.getOuterLeftQTIColor)
    PC.AddValueInt(String("QTI-OR-COLOR"), Sensor.getOuterRightQTIColor) }
    'PC.AddValueInt(String("LSPeed"), Mtr.GetRightSpeed)

    {

    if SEND_AUXILLARY_INFO==true
      '---{Color Sensors}---'
      PC.AddValueInt(String("Left-Red"), Sensor.getLeftRed)
      PC.AddValueInt(String("Left-Green"), Sensor.getLeftGreen)
      PC.AddValueInt(String("Left-Blue"), Sensor.getLeftBlue)
      PC.AddValueInt(String("Right-Red"), Sensor.getRightRed)
      PC.AddValueInt(String("Right-Green"), Sensor.getRightGreen)
      PC.AddValueInt(String("Right-Blue"), Sensor.getRightBlue)
       
      '---{Gyro}---'
      PC.AddValueInt(String("X"), Sensor.getX)
      PC.AddValueInt(String("Y"), Sensor.getY)
      PC.AddValueInt(String("Z"), Sensor.getZ)
      PC.AddValueInt(String("Heading"), Sensor.getDegrees)
       
      '---{Ultrasonic}---'
      PC.AddValueInt(String("Ping L"), Sensor.getCmMiddle)
      PC.AddValueInt(String("Ping R"), Sensor.getCmRight)
       
      '---{Buttons}---'
      PC.AddValueInt(String("LeftButton"), Sensor.GetButtonLeft)
      PC.AddValueInt(String("RightButton"), Sensor.GetButtonRight)
       
      '---{Program}---'
      PC.AddValueInt(STring("Main Loop Speed"), logicspeed)
      PC.AddValueInt(String("Main Sensor Loop Speed"), Sensor.GetFastLastMs)
      PC.AddValueInt(String("Main Sensor Loop Speed Full"), Sensor.GetFastLastMsFull)
      PC.AddValueInt(String("Secondary Sensor Loop Speed"), Sensor.GetSlowLastMs)
      PC.AddValueInt(String("Debug Loop Speed"), t)
      PC.AddValueInt(String("Cogs Running"), Cog.getUsedCogs)
       
      '---{Course}---'
      PC.AddValueStr(String("Location"), location) }

    '---{LCD}---'
    
    LCD.ClearScreen
    LCD.FirstLine
    LCD.StrCenter(location)
    LCD.SecondLine
    LCD.Str(String("   "))
    LCD.Str( Num.dec(Sensor.getOuterLeftQTIColor))
    LCD.Str(String(", "))
    LCD.Str( Num.dec(Sensor.getLeftQTIColor))
    LCD.Str(String(", "))
    LCD.Str( Num.dec(Sensor.getMiddleQTIColor))
    LCD.Str(String(", "))
    LCD.Str( Num.dec(Sensor.getRightQTIColor))
    LCD.Str(String(", "))
    LCD.Str( Num.dec(Sensor.getOuterRightQTIColor))
    {LCD.ThirdLine
    LCD.Dec(Sensor.getLeftRed)
    LCD.Str(String(", "))
    LCD.Dec(Sensor.getLeftGreen)
    LCD.Str(String(", "))
    LCD.Dec(Sensor.getLeftBlue)
    LCD.Str(STring(", "))
    LCD.Str(Sensor.getLeftCPALColor)
    LCD.ForthLine
    LCD.Dec(Sensor.getRightRed)
    LCD.Str(String(","))
    LCD.Dec(Sensor.getRightGreen)
    LCD.Str(String(","))
    LCD.Dec(Sensor.getRightBlue)
    LCD.Str(STring(", "))
    LCD.Dec(timeFromLastGreenTurn)}
    LCD.ThirdLine
    LCD.Dec(Sensor.getMmMiddle)
    LCD.Str(String(", "))
    LCD.Dec(Sensor.getArmButton)
    LCD.Str(String(", "))
    LCD.Dec(timeFromLastGreenTurn)
    LCD.Str(String(", "))
    LCD.Dec(prevDist)
    LCD.CR
    LCD.Dec(Sensor.getMmRight)
    LCD.Str(String(", "))
    LCD.Dec(timeFromLastGreenTurn)
    LCD.Str(String(", "))
    LCD.Dec(InGreenTile)
    LCD.Str(string(","))
    LCD.Str(Sensor.getLeftCPALColor)
    LCD.Str(string(","))
    LCD.Str(Sensor.getRightCPALColor)
    
    
    Profiler1.Stoptimer
    t := Profiler1.getTimeMs
  